/* crypt */

#include "../include/crypt.h"

int crypt (char *kfile, char *mfile, char *ofile, int base)
{
	char z;

	mpz_class n = 0, e = 0;
	mpz_class mesg = 0;

	ifstream pub (kfile, ios::in);
	pub >> z >> z >> n;
	pub >> z >> z >> e;
	pub.close ();

	FILE *input;
	input=fopen(mfile, "rb");
	mpz_inp_str (mpz(mesg), input, base);
	fclose(input);
	
	mpz_powm (mpz (mesg), mpz (mesg), mpz (e), mpz (n));	//mesg=mesg^e mod m 

	FILE *output;
	output=fopen(ofile, "wb");
	mpz_out_str (output, base, mpz(mesg)) ;
	fclose(output);

	return 0;
}
